/* global Bdf,$$,SelectionDef,Pane */

SelectionDef.Form = {};

SelectionDef.Form.load = function (selectionDefName) {
    var selectionDef = SelectionDef.getSelectionDef(selectionDefName);
    if (!selectionDef) {
        return;
    }
    var isInStock = false;
    var formId = Bdf.generateId();
    $$("layout_main").html(Bdf.render("selectiondef:form", {
        action: Bdf.URL + "selection",
        formId: formId,
        selectionDefName: selectionDef.name,
        title: selectionDef.title,
        labelArray: Bdf.toLabelArray(selectionDef.labelMap),
        labelsLocKey: "_ title.selection.selectiondeflabels",
        queryXml: selectionDef.query.ficheXml + selectionDef.query.motcleXml,
        attributes: Bdf.attrMapToString(selectionDef.attrMap),
        attributesLocKey: "_ title.selection.selectiondefattributes",
        commandKey: "EXP-03",
        commandUrl: Bdf.getCommandUrl("EXP-03")
    }));
    Bdf.Deploy.init($$("layout_main"));
    $$(formId, "button_stock").click(function () {
        Pane.moveMainToStock();
    });
    $$(formId, "button_test").click(function () {
        SelectionDef.Overlay.showSelectionTest(selectionDefName);
    });
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            if (isInStock) {
                return false;
            } else {
                queryxmlCodeMirror.save();
                attributesCodeMirror.save();
                return true;
            }
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var queryxmlCodeMirror = Bdf.toCodeMirror(ID(formId, "queryxml"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "xml"
    });
    queryxmlCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    $$(formId, "button_queryparser").click(function () {
        Bdf.Overlay.showFqlEditor(queryxmlCodeMirror.getDoc().getValue(), function (result) {
            queryxmlCodeMirror.getDoc().setValue(result);
        });
    });
    var attributesCodeMirror = Bdf.toCodeMirror(ID(formId, "attributes"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    $$(formId).data("stockHandler", _stockHandler);
    Pane.checkState();
    Pane.checkTooltip($$(formId));
    

    function _saveCallback(data) {
        Bdf.showCommandMessage(data.commandMessage);
        if (data.commandMessage.type === "done") {
            Bdf.updateDefaultValues($$(formId));
            let newSelectionDef = SelectionDef.updateSelectionDef(data.selectionDef);
            Bdf.$($$(formId), {role: "metadata-title"}).html(newSelectionDef.title);
        }
    }
    
    function _stockHandler(stock) {
        isInStock = stock;
        queryxmlCodeMirror.setOption("readOnly", stock);
        attributesCodeMirror.setOption("readOnly", stock);
        Pane.setReadOnly($$(formId), stock);
    }
    
};
